#include <bits/stdc++.h>
using namespace std;
long long x, n, m, a[50005], b[50005], c[50005], d[50005], x1[50005], y[50005], res[50005];
bool br1=true;

void set3(){
   int br=0;
   int brkrompira=0;
   while(b[1]>0){
      for(int i=1; i<=m; i++){
         if(c[i]>0){
            if(br1)br++;
            brkrompira++;
            y[br]=i;
            res[br]=c[i];
            b[1]-=c[i];
            c[i]=d[i]-c[i];
         }
      }
      br1=false;
   }
   cout << brkrompira << endl << br << endl;
   for(int i=1; i<=br; i++){
      printf("1 ");
      printf("%lld ", y[i]);
      printf("%lld ", res[i]);
      printf("\n");
   }
}

int main(){
   scanf("%lld", &n);
   scanf("%lld", &m);
   for(int i=1; i<=n; i++){
      scanf("%lld", &a[i]);
      scanf("%lld", &b[i]);
   }
   for(int i=1; i<=m; i++){
      scanf("%lld", &c[i]);
      scanf("%lld", &d[i]);
   }
   set3();
   return 0;
}